
'''
Numerical Analysis II, ETH Zurich
Summer Exam, 2021

Templates for Problem II
'''

import numpy as np
import matplotlib.pyplot as plt


T = # final time
step = # step size
datum = # initial data
N = # number of approximations
t = np.linspace(0,T,N) # time-grid


def build_matrix(h):    
    ''' 
    TODO: Implement the matrix of the scheme in (2.6)
    
    INPUT
        h: the step of the method
    OUTPUT
        the matrix of the method
    '''
    pass


def build_matrix_composition(h):
    ''' 
    TODO: Implement the matrix of the composition of the scheme in (2.6) with its adjoint 
    
    INPUT
        h: the step-size of the method
    OUTPUT
        the matrix of the method
    '''

    pass


def solver(A, step, T, datum):
    '''
    TODO: Implement the solver for the numerical scheme associated to matrix A
    
    INPUT
        A: matrix of the scheme
        step: the step-size
        T: the final time
        datum: initial datum for the ODE system
    OUTPUT
        the solution as a Nx2 matrix, the first and second columns refer to x and p (resp.)
    
    '''
    pass





''' TODO: call  solver() with proper arguments '''



def energy_fun(x,p):
    '''TODO: Implement the energy H(x,p)'''
    pass


''' TODO: you might adapt the snippet below to plot the solutions '''

# Plot the numerical solutions 
fig1, ((ax1,ax2),(ax3,ax4)) = plt.subplots(ncols=2,nrows=2,figsize=(10,5))
ax1.plot()
ax2.plot()
ax1.axis('equal')
ax2.axis('equal')
ax1.set_title("Numerical scheme 2.6")
ax2.set_title("Composition")


# Plot the values of the energy for the two numerical solutions 
ax3.plot()
ax4.plot()
ax3.axis('equal')
ax4.axis('equal')

ax3.set_title("$H(x^k,p^k)$")
ax4.set_title("$H(x^k,p^k)$")
plt.show()



'''
TODO: Validate the orders of the two numerical methods
'''


def trunc_err(h,k, sol):
	pass


stepsizes = np.linspace(0.001,0.00001,100)
vals = list()
vals_compos = list()
''' TODO: fill in vals and vals_compos with the norm of the truncation error '''


''' TODO: you might adapt the snippet below to plot the results '''

fig, (ax1,ax2) = plt.subplots(ncols=2,nrows=1,figsize=(10,5))
fig.suptitle("Orders")
ax1.plot(stepsizes,vals)
ax1.plot(stepsizes, stepsizes/1.9)
ax1.legend(["$|T_k(\Delta t)|, k =1$","$C_1 \Delta t$"])
ax1.invert_xaxis()
ax1.set_title("Order of numerical scheme in 2.6")

ax2.plot(stepsizes,vals_compos)
ax2.plot(stepsizes, stepsizes**2/11)
ax2.legend(["$|T_k(\Delta t)|, k =1$","$C_2 \Delta t^2$"])
ax2.invert_xaxis()
ax2.set_title("Order of the composition")
plt.show()
